package at.jku.fim.datalinksimulation.genericdevices;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: HardwareComponent.java,v 1.1 2005/10/27 13:10:07 aputzinger Exp $
 */

public abstract class HardwareComponent {

    /** each hardware component gets it's unique id */
    private static int componentIDCounter = 0;

    /**
     * Personal hardware component ID of this instance<BR/>
     * These components
     */
    protected int networkComponentId;

    /**
     * Constructor 
     */
    public HardwareComponent() {
        networkComponentId = componentIDCounter++;
    }

    /**
     * @return Returns Network Component ID
     */
    public int getNetworkComponentId() {
        return networkComponentId;
    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
    public String toString() {
        return "Network Component #" + networkComponentId;
    }

}