package at.jku.fim.datalinksimulation.layer1.wire.damagedwire;

import at.jku.fim.datalinksimulation.layer1.data.RawData;
import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * A very simple implementation of a cable defect; a random bit of a random byte of the frame is inverted.
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: SimpleDamagingStrategy.java,v 1.1 2005/10/27 13:10:07 aputzinger Exp $
 */

public class SimpleDamagingStrategy implements DamagingStrategy {

	/** Logger instance to use */
	protected Logger logger = new Logger("Damaged Wire");

	/*
	 * (non-Javadoc)
	 * 
	 * @see at.jku.fim.datalinksimulation.layer1.wire.damagedwire.DamagingStrategy#damageData(at.jku.fim.datalinksimulation.data.RawData)
	 */
	public RawData damageData(RawData data) {
		int[] oldData = data.getRawDataBulk();
		int randNumber = (int) (Math.random() * oldData.length);
		int randBit = (int) (Math.random() * 8);
		logger.log("HARR HARR HARR - Inverting bit #" + (randBit + 1)
				+ " of byte #" + (randNumber + 1) + " in given frame");
		oldData[randNumber] = (int) (oldData[randNumber] ^ Math.round(Math.pow(
				2, randBit)));
		data.setRawDataBulk(oldData);
		return data;
	}

}
