package at.jku.fim.datalinksimulation.networkstack.outgoing;

import at.jku.fim.datalinksimulation.layer1.data.RawData;
import at.jku.fim.datalinksimulation.networkstack.NetworkFilter;
import at.jku.fim.datalinksimulation.networkstack.NetworkStackParameters;
import at.jku.fim.datalinksimulation.utils.Logger;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: EncodingNetworkFilter.java,v 1.1 2005/10/27 13:10:11 aputzinger Exp $
 */

public interface EncodingNetworkFilter extends NetworkFilter {

    /**
     * Performs an encoding step within the outgoing network stack
     * @param params network stack params
     * @param data data from upper layer or previous filter
     * @param logger Logger instance
     * @return Returns encoded data
     */
    public RawData encode(NetworkStackParameters params, RawData data,
            Logger logger);

    /**
     * @return Short description of this filter implementation
     */
    public String getDescription();

}