package at.jku.fim.datalinksimulation.scenario.gui;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.border.TitledBorder;

import at.jku.fim.datalinksimulation.scenario.SystemScenarioModel;

/**
 * <p>Title: OSI Simulation Framework</p>
 * <p>Copyright: (c) 2004-05</p>
 * <p>Company: FIM@JKU, www.fim.uni-linz.ac.at</p>
 * @author Andreas Putzinger
 * @version $Id: SystemScenarioGUI.java,v 1.1 2005/10/27 13:10:08 aputzinger Exp $
 */

public class SystemScenarioGUI extends JFrame {

	private static final long serialVersionUID = 6441687885868801898L;

	BorderLayout borderLayout1 = new BorderLayout();

    JPanel mainPanel = new JPanel();

    BorderLayout borderLayout2 = new BorderLayout();

    JPanel simulationControllerPanel = new JPanel();

    JPanel informationPanel = new JPanel();

    JPanel canvasPanel = new JPanel();

    SenderPanel station1Panel = new SenderPanel(SystemScenarioModel.getInstance()
            .getSendAppStation1());

    ReceiverPanel station10Panel = new ReceiverPanel();

    Icon icon = new ImageIcon(getClass().getResource("images/infrastructure.jpg"));

    JLabel jLabel1 = new JLabel();

    ReceiverPanel station11Panel = new ReceiverPanel();

    LogPanel logPanel1 = new LogPanel();

    BorderLayout borderLayout3 = new BorderLayout();

    BorderLayout borderLayout4 = new BorderLayout();

    JPanel jPanel1 = new JPanel();

    BorderLayout borderLayout5 = new BorderLayout();

    JPanel jPanel2 = new JPanel();

    JPanel jPanel3 = new JPanel();

    JLabel jLabel2 = new JLabel();

    BorderLayout borderLayout6 = new BorderLayout();

    TitledBorder titledBorder1;

    TitledBorder titledBorder2;

    TitledBorder titledBorder3;

    JToggleButton damagingButton = new JToggleButton();

    public SystemScenarioGUI() {
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void logUpdate() {
        logPanel1.showSelectedLog();
    }

    public void stationsReset() {
        station10Panel.setSenderID("N/A");
        station10Panel.getPlainText().setText("");
        station10Panel.getHexText().setText("");
        station11Panel.setSenderID("N/A");
        station11Panel.getPlainText().setText("");
        station11Panel.getHexText().setText("");
    }

    void jbInit() throws Exception {
        titledBorder1 = new TitledBorder("");
        titledBorder2 = new TitledBorder("");
        titledBorder3 = new TitledBorder("");
        this.setTitle("Data Link Simulation");
        this.getContentPane().setLayout(borderLayout1);
        mainPanel.setLayout(borderLayout2);
        simulationControllerPanel.setBackground(Color.white);
        simulationControllerPanel.setLayout(borderLayout4);
        informationPanel.setBackground(Color.white);
        informationPanel.setLayout(borderLayout3);
        canvasPanel.setLayout(null);
        station1Panel.setBounds(new Rectangle(16, 8, 250, 255));
        station10Panel.setBounds(new Rectangle(452, 8, 335, 125));
        station11Panel.setBounds(new Rectangle(452, 141, 335, 125));
        jLabel1.setBorder(BorderFactory.createEtchedBorder());
        jLabel1.setIcon(icon);
        jLabel1.setText("jLabel1");
        jLabel1.setBounds(new Rectangle(-1, 0, 800, 279));
        canvasPanel.setMinimumSize(new Dimension(100, 100));
        canvasPanel.setPreferredSize(new Dimension(1, 270));
        mainPanel.setMaximumSize(new Dimension(800, 1000));
        mainPanel.setMinimumSize(new Dimension(100, 100));
        jPanel1.setLayout(borderLayout5);
        jPanel2.setBackground(Color.orange);
        jPanel2.setAlignmentY((float) 0.5);
        jPanel2.setLayout(borderLayout6);
        jLabel2.setFont(new java.awt.Font("Dialog", 1, 17));
        jLabel2.setBorder(titledBorder2);
        jLabel2.setMaximumSize(new Dimension(500, 30));
        jLabel2.setMinimumSize(new Dimension(500, 30));
        jLabel2.setPreferredSize(new Dimension(500, 30));
        jLabel2.setRequestFocusEnabled(true);
        jLabel2.setText("OSI Layer 2 Network Simulation");
        logPanel1.setBorder(titledBorder3);
        damagingButton.setBackground(Color.red);
        damagingButton.setSelected(true);
        damagingButton.setText("X");
        damagingButton.setBounds(new Rectangle(270, 90, 50, 23));
        damagingButton
                .addActionListener(new Simulation_damagingButton_actionAdapter(
                        this));
        this.getContentPane().add(mainPanel, BorderLayout.CENTER);
        mainPanel.add(simulationControllerPanel, BorderLayout.NORTH);
        simulationControllerPanel.add(canvasPanel, BorderLayout.CENTER);
        mainPanel.add(informationPanel, BorderLayout.CENTER);
        informationPanel.add(logPanel1, BorderLayout.CENTER);
        canvasPanel.add(station1Panel, null);
        canvasPanel.add(station10Panel, null);
        canvasPanel.add(station11Panel, null);
        canvasPanel.add(damagingButton, null);
        canvasPanel.add(jLabel1, null);
        simulationControllerPanel.add(jPanel1, BorderLayout.NORTH);
        jPanel1.add(jPanel2, BorderLayout.NORTH);
        jPanel2.add(jLabel2, BorderLayout.CENTER);
        jPanel1.add(jPanel3, BorderLayout.CENTER);
        SystemScenarioModel.getInstance().getSendAppStation1().setGui(station1Panel);
        SystemScenarioModel.getInstance().getRecAppStation10()
                .setGui(station10Panel);
        SystemScenarioModel.getInstance().getRecAppStation11()
                .setGui(station11Panel);
        stationsReset();
    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.Window#processWindowEvent(java.awt.event.WindowEvent)
	 */
    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            System.exit(0);
        }
    }

    void damagingButton_actionPerformed(ActionEvent e) {
        Color damagingActive = Color.RED;
        Color damagingInactive = Color.GREEN;
        damagingButton.setSelected(damagingButton.isSelected());
        if (damagingButton.isSelected()) {
            damagingButton.setBackground(damagingActive);
            damagingButton.setText("X");
            SystemScenarioModel.getInstance().getDamagedWire().setDamagingEnabled(
                    true);
        } else {
            damagingButton.setBackground(damagingInactive);
            damagingButton.setText("OK");
            SystemScenarioModel.getInstance().getDamagedWire().setDamagingEnabled(
                    false);
        }
    }

}

class Simulation_damagingButton_actionAdapter implements
        java.awt.event.ActionListener {
    SystemScenarioGUI adaptee;

    Simulation_damagingButton_actionAdapter(SystemScenarioGUI adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.damagingButton_actionPerformed(e);
    }
}